import java.util.*;
import java.lang.*;
import java.io.*;
import java.net.*;
import javax.swing.text.*; 
import javax.swing.text.html.*;
import javax.swing.text.html.parser.*;



public class GetPhrases {

  private HashMap indeces = new HashMap();
  private String[] phraseFiles = {"foodPhr.txt" , "accomodationPhr.txt", "travelPhr.txt" ,
				  "leisurePhr.txt" , "storePhr.txt" , "servicePhr.txt" ,
				"healthPhr.txt" , "emergencyPhr.txt"};
  private int x = phraseFiles.length;
  private ArrayList dbase = new ArrayList();
  
  public GetPhrases() {
    setup();
  }

  private void setup() {
    
    indeces.put("Food & Dining", new Integer(0));
    indeces.put("Accomodations", new Integer(1));
    indeces.put("Travel & Transportation", new Integer(2));
    indeces.put("Leisure", new Integer(3));
    indeces.put("Shopping", new Integer(4));
    indeces.put("Services", new Integer(5));
    indeces.put("Health & Safety", new Integer(6));
    indeces.put("Emergency", new Integer(7));
    
    Eliminator eli = new Eliminator();

    for(int i = 0; i<x; i++) {
      try{
	FileReader reader = new FileReader((String) phraseFiles[i]);
	BufferedReader breader = new BufferedReader(reader);
	ArrayList temp1 = new ArrayList();
	ArrayList temp2 = new ArrayList();
	ArrayList temp3 = new ArrayList();	
	ArrayList words = new ArrayList();
	String[] str;
	while (breader.ready()) {
	  String phrase = breader.readLine();
	  //****************
	  temp1.add(phrase);
	  //****************

	  str = phrase.split(" ", 0);
	  words = new ArrayList();

	  for(int y=0; y<str.length; y++)
	    {
	      words.add((String) str[y]);
	    }
	  
	  words = eli.eliminate(words);

	  //****************
	  temp2.add(words);
	  //****************
	}
	
	temp3.add(temp1);
	temp3.add(temp2);
	dbase.add(temp3);
      }
      catch(FileNotFoundException e) {
	System.out.println("file not found");
      }
      catch(IOException e) {
	System.out.println("could not read file");
      }     
    }
  }

  public int getIndex(String string) {
    if(indeces.get(string) == null)
      return -1;
    
    Integer i = (Integer) indeces.get(string);
    return i.intValue();
  }

  public ArrayList queryForPhrases(ArrayList keywords, String context) {
    if(context.equals("Other"))
      return askOpenMind(keywords);
    return giveMePhrases(keywords, context);
  }

  public ArrayList askOpenMind(ArrayList keywords) {
    ArrayList output = new ArrayList();
    ArrayList output2 = new ArrayList();
    ArrayList words = new ArrayList();
    GetWords2 g = new GetWords2();
    
    //ArrayList queryList = keywords;
    ArrayList queryList = g.queryAllRelationsGiveMeRelevantToAll(keywords);
    queryList = g.combine(keywords, queryList);
    
    
    System.out.println(queryList);


    int k = queryList.size();
    String zzz = "";

    for(int i = 0; i<k; i++) {
      zzz = (String) queryList.get(i);

    try 
      {
	//Contruct URL for OMCNet Web Interface
	URL source = new URL("http://openmind.media.mit.edu/cgi-bin/get.cgi?concept="+zzz+"&number=50");
	
	//Connect to OMCNet web interface.
	OnlineConnection service_connection = new OnlineConnection(source);
	
	// Obtain content of target.  
	//	HTMLDocument document = new HTMLDocument();
	InputStream input;
	
	String line;
	String[] str;
	Eliminator eli = new Eliminator();

	try
	  {
	    Object o = source.getContent();
	    
	    input = (InputStream) o;
	    InputStreamReader isr = new InputStreamReader( input );
	    BufferedReader in = new BufferedReader( isr );
	    while ( (line = in.readLine() ) != null )
	      {
		output.add(line);

		str = line.split(" ", 0);
		words = new ArrayList();
		
		for(int y=0; y<str.length; y++)
		  {
		    words.add((String) str[y]);
		  }
		
		words = eli.eliminate(words);
		
		//****************
		output2.add(words);
		//****************

	      }
	    in.close();	    
	  }
	catch(IOException e)
	  {
	    System.err.println("ERROR 1: Something went wrong.\n" + e);	
	  }
      }
    catch(MalformedURLException e)
      {
	System.err.println("ERROR 3: Something went wrong.\n" + e);	
      }
    }


    HashMap query = new HashMap();
    int zxc = queryList.size();
    Integer iii = new Integer(1);

    for(int t=0; t<zxc; t++) 
      {
	query.put(queryList.get(t), iii);
      }

    int h = output.size();
    ArrayList sentKeys = new ArrayList();
    int kl = 0;
    int counter = 0;
    String sentence = "";
    ArrayList answerSentences = new ArrayList();
    ArrayList score = new ArrayList();

    for (int f=0; f<h; f++)
      {
	sentence = (String) output.get(f);

	//System.out.println(sentence);

	sentKeys  = (ArrayList) output2.get(f);
	kl = sentKeys.size();
	counter = 0;

	if(kl > 0)
	  {
	    for (int b=0; b<kl; b++)
	      {
		if(query.get((String) sentKeys.get(b)) != null)
		  counter++;
	      }
	    score.add(new Integer(counter));
	    answerSentences.add(sentence);
	  }
	else 
	  {
	    score.add(new Integer(0));
	    answerSentences.add(sentence);
	  }
      }

    ArrayList phraseAnswer = insertSort(answerSentences, score);
    
    return phraseAnswer;
  }


  /*  public ArrayList queryForPhrases(ArrayList keywords, String context) {
    ArrayList answer = new ArrayList();
    ArrayList temp = new ArrayList();
    ArrayList t = new ArrayList();
    
    temp = giveMePhrases(keywords, context);

    int j = temp.size();
    
    for(int k = 0; k<j; k++)
      {
	t = (ArrayList) temp.get(k);
	answer.add((String) t.get(0));
      }
    
    return answer;
    }*/


  public ArrayList giveMePhrases(ArrayList keywords, String context) {

    GetWords2 g = new GetWords2();

    ArrayList blah = new ArrayList();
    ArrayList kw = new ArrayList();
    //***Synonyms***
    //for (int v=0; v<keywords.size(); v++) 
    //{
    //kw = g.combine(kw, g.getSynonyms((String) keywords.get(v)));
    //}
    //kw = g.combine(keywords, kw);
    //ArrayList queryList = kw;
    //ArrayList queryList = keywords;
    ArrayList queryList = g.queryAllRelationsGiveMeRelevantToAll(keywords);
    queryList = g.combine(keywords, queryList);
     
    
    System.out.println(queryList);

    HashMap query = new HashMap();
    int z = queryList.size();
    Integer iii = new Integer(1);

    for(int t=0; t<z; t++) 
      {
	query.put(queryList.get(t), iii);
      }
    
    
    int cont = getIndex(context);
    
    ArrayList subDB = (ArrayList) dbase.get(cont);
    //System.out.println(subDB);
    ArrayList sentences = (ArrayList) subDB.get(0);
    ArrayList sentencesKeys = (ArrayList) subDB.get(1);

    //System.out.println(sentences);

    ArrayList score = new ArrayList();
    String sentence = "";
    ArrayList sentKeys = new ArrayList();
    int h = ((ArrayList) subDB.get(0)).size();
    ArrayList answerSentences = new ArrayList();
    int kl = 0;
    int counter = 0;
    
    for (int j=0; j<h; j++)
      {
	sentence = (String) sentences.get(j);

	//System.out.println(sentence);

	sentKeys  = (ArrayList) sentencesKeys.get(j);
	kl = sentKeys.size();
	counter = 0;

	if(kl > 0)
	  {
	    for (int b=0; b<kl; b++)
	      {
		if(query.get((String) sentKeys.get(b)) != null)
		  counter++;
	      }
	    score.add(new Integer(counter));
	    answerSentences.add(sentence);
	  }
	else 
	  {
	    score.add(new Integer(0));
	    answerSentences.add(sentence);
	  }
      }
    

    //ArrayList cloneSubDB = new ArrayList();
    //for (int a=0; a<h; a++)
    //{
    //cloneSubDB.add((ArrayList) subDB.get(a));
    //}

    //System.out.println(answerSentences);
    System.out.println(score);
    if(answerSentences.size()>0)
      {
	ArrayList phraseAnswer = insertSort(answerSentences, score);    
	return phraseAnswer;
      }
    return new ArrayList();
  }
  


  private static ArrayList insertSort(ArrayList words, ArrayList scores) {
    ArrayList answer = new ArrayList();
    ArrayList tempScore = new ArrayList();
    int length = words.size();
    if(length == scores.size())
      {
	if(length >= 0)
	  {
	    answer.add(words.get(0));
	    tempScore.add(scores.get(0));
	  }
	
	int i;
	int key;
	int a_i;
	Integer integ;
	Integer integ2;
	Integer integ3;
	
	if(length > 0)
	  {
	    for(int j = 1; j<length; j++)
	      {
		integ = (Integer) scores.get(j);
		key = integ.intValue();
		
		for(int k=j-1; k>=0; k--)
		  {
		    integ2 = (Integer) tempScore.get(k);
		    if(integ2.intValue() < key)
		      {
			answer.add(k+1, words.get(j));
			tempScore.add(k+1, scores.get(j));
			break;
		      }
		    else if (k==0)
		      {answer.add(k, words.get(j));
		      tempScore.add(k, scores.get(j));}
		  }
	      }
	    
	  }
      }
    
    int zz=answer.size();
    ArrayList reverseSort = new ArrayList();
    for(int dd=1; dd<=zz; dd++)
      {
	reverseSort.add(answer.get(zz-dd));
      }
    //System.out.println(tempScore);
    return reverseSort;
  }


  public ArrayList translate(ArrayList input, String from, String to, int x) {
    Translator tr = new Translator();
    tr.setLang(to);
    tr.setFromLang(from);
    int startFrom = 20*x;
    int length = input.size();
    ArrayList answer = new ArrayList();
    String str = "";
    int z=0;
    int w = Math.min(length, startFrom+20);
    int r = w - startFrom;

    if(startFrom < length)
      {
	String trWord = "";
	String[] strArray;
	for(int i=startFrom; i<w ; i++)
	  {
	    trWord = tr.translate((String) input.get(i));
	    strArray = trWord.split("_ ", 0);
	    answer.add(strArray[0]);
	  }
      }
    //	System.out.println(answer);
	return answer;
  }

  public ArrayList translatedList(ArrayList input, int x) {
    int startFrom = 20*x;
    int length = input.size();
    ArrayList answer = new ArrayList();
    int w = Math.min(length, startFrom+20);
    
    if(startFrom < length)
      {
	for(int i=startFrom; i<w ; i++)
	  {
		answer.add(input.get(i));
	  }
      }
    return answer;
  }




}
