import java.util.*;
import java.net.*;
import java.io.*;
import javax.swing.text.*; 
import java.lang.*;
import javax.swing.text.html.*;
import javax.swing.text.html.parser.*;

public class GetWords {
  
  OMCNet extractor;
  Hashtable table = new Hashtable();
  ArrayList list = new ArrayList();
  ArrayList relationsNames = new ArrayList();
  ArrayList relations = new ArrayList();
   
    public GetWords() {
	extractor = new OMCNet();
	relationsNames = extractor.getRelations();   
    }

    
    public Hashtable queryAllRelationsOneByOne(ArrayList keywords) {
	ArrayList relns = extractor.getRelations();
	Hashtable answer = new Hashtable();
	int numOfRelations = relns.size();

	for(int i = 0; i<numOfRelations; i++)
	    {
		answer.put(relns.get(i), queryRelation(keywords, (String) relns.get(i)));
	    }
	
	return answer;
    }    


  public ArrayList filter(ArrayList lis) {
    Eliminator eli = new Eliminator();
    int x = lis.size();
    String str;
    String[] strArray;
    ArrayList temp = new ArrayList();
    ArrayList answer = new ArrayList();
    int length=0;
    
    for (int i=0 ; i<x ; i++) 
      {
	str = (String) lis.get(i);
	strArray = str.split(" ", 0);
	length = strArray.length;
	for(int j=0; j<length; j++)
	  {
	    temp.add(strArray[j]);
	  }
      }
    //System.out.println(temp);
    answer = temp;
    //answer = combine(answer, eli.eliminate(temp));
    return answer;
  }


  public ArrayList translate(ArrayList input, String from, String to, int x) {
    Translator tr = new Translator();
    tr.setLang(to);
    tr.setFromLang(from);
    int startFrom = 20*x;
    int length = input.size();
    ArrayList answer = new ArrayList();
    String str = "";
    int z=0;
    int w = Math.min(length, startFrom+20);

    if(startFrom < length)
      {
	for(int i=startFrom; i<w ; i++)
	  {
	    if(z==0)
	      {
		str = str + (String) input.get(i);
		z = 1;
	      }
	    else
	      {
		str = str + " - " + (String) input.get(i);
	      }
	  }
	
	String ans = tr.translate(str);
	String[] strArray;
	strArray = ans.split(" - ", 0);
	int l = strArray.length;
	for(int j=0; j<l; j++)
	  {
	    answer.add(strArray[j]);
	  }
      }
    return answer;
  }


  public ArrayList translatedList(ArrayList input, int x) {
    int startFrom = 20*x;
    int length = input.size();
    ArrayList answer = new ArrayList();
    int w = Math.min(length, startFrom+20);
    
    if(startFrom < length)
      {
	for(int i=startFrom; i<w ; i++)
	  {
		answer.add(input.get(i));
	  }
      }
    return answer;
  }
  
  
  public ArrayList queryRelation(ArrayList keywords, String relation) {
    int numOfKeywords = keywords.size();
    ArrayList ls = new ArrayList();
    ArrayList l1;
    ArrayList l2;
    ArrayList allOutput = new ArrayList();
    ArrayList answer = new ArrayList();
    ArrayList answerWord = new ArrayList();
    ArrayList answerScore = new ArrayList();

    //FINDING THE QUERIES RESULTS:
    //----------------------------
    for (int j=0; j<numOfKeywords; j++) {
      l1 = extractor.getWordsWithSource((String) keywords.get(j), relation);
      l2 = extractor.getWordsWithTarget((String) keywords.get(j), relation);
      l1 = combine(l1, l2);
      allOutput = combine(allOutput, l1);  //build a collection for
                                           //all the outputs that
					   //come up

      ls.add(l1);             //add to the list of lists of output
    }
    
    
    //FINDING THE STATISTICS:
    //-----------------------
    ArrayList kwoutput;
    int sizeOfOutput = allOutput.size();
    Integer integ;
    int z=0;
    int t=0;
    int d=0;

    for (int j=0; j<numOfKeywords; j++) {  
      kwoutput = (ArrayList) ls.get(j);  //outpout for one keyword
				         //for current relation
	
      z = kwoutput.size();
      for (int k=0; k < z; k++) {
	  if(!answerWord.contains(kwoutput.get(k)))
	      {
		  answerWord.add(kwoutput.get(k));
		  answerScore.add(new Integer(1));
	                        //create 2 lists
		                //with output for
   		            	//one keyword for
		                //this relation.
	      }
      }
      
      for (int m=0; m<sizeOfOutput; m++) {     //go through the
	  //output and find the
	  //statistics of the
	  //occurance of each
	  //output word/phrase
	  if(answerWord.contains(allOutput.get(m)))
	      {
		  t = answerWord.indexOf(allOutput.get(m));
		  integ = (Integer) answerScore.get(t);
		  d = integ.intValue();
		  d++;
		  answerScore.set(t, new Integer(d));
	      }
	}
    }
    
    answer = insertSort(answerWord, answerScore);
    
    return answer;
  }
    

    public ArrayList queryAllRelations(ArrayList keywords) {
    int numOfKeywords = keywords.size();
    ArrayList ls = new ArrayList();
    ArrayList l1;
    ArrayList l2;
    ArrayList allOutput = new ArrayList();
    ArrayList answer = new ArrayList();
    ArrayList answerWord = new ArrayList();
    ArrayList answerScore = new ArrayList();

    //FINDING THE QUERIES RESULTS:
    //----------------------------
    for (int j=0; j<numOfKeywords; j++) {
      l1 = extractor.getWordsWithSource((String) keywords.get(j));
      l2 = extractor.getWordsWithTarget((String) keywords.get(j));
      l1 = combine(l1, l2);
      allOutput = combine(allOutput, l1);  //build a collection for
                                           //all the outputs that
					   //come up

      ls.add(l1);             //add to the list of lists of output
    }
    
    
    //FINDING THE STATISTICS:
    //-----------------------
    ArrayList kwoutput;
    int sizeOfOutput = allOutput.size();
    Integer integ;
    int z=0;
    int t=0;
    int d=0;

    for (int j=0; j<numOfKeywords; j++) {  
      kwoutput = (ArrayList) ls.get(j);  //outpout for one keyword
				         //for all relations
	
      z = kwoutput.size();
      for (int k=0; k < z; k++) {
	  if(!answerWord.contains(kwoutput.get(k)))
	      {
		  answerWord.add(kwoutput.get(k));
		  answerScore.add(new Integer(1));
	                        //create 2 lists
		                //with output for
   		            	//one keyword for
		                //this relation.
	      }
	}
	
	for (int m=0; m<sizeOfOutput; m++) {     //go through the
						 //output and find the
						 //statistics of the
						 //occurance of each
						 //output word/phrase
	  if(answerWord.contains(allOutput.get(m)))
	    {
		t = answerWord.indexOf(allOutput.get(m));
		integ = (Integer) answerScore.get(t);
		d = integ.intValue();
		d++;
		answerScore.set(t, new Integer(d));
	    }
	}
    }

    answer = insertSort(answerWord, answerScore);
    //System.out.println(answerScore);
    return answer;
  }


  public ArrayList queryWithSysnonymsAllRelations(ArrayList keywords) {
    
    ArrayList newKeywords = new ArrayList();
    ArrayList temp;
    int numOfKeywords = keywords.size();
    for(int i=0; i<numOfKeywords; i++) 
      {
	temp = extractor.getSynonyms((String) keywords.get(i));
	newKeywords = combine(newKeywords, temp);
      }
    
    newKeywords = combine(newKeywords, keywords);
    
    ArrayList answer = new ArrayList();
    answer = queryAllRelations(newKeywords);
    return answer;
  }


  public ArrayList queryWithSysnonymsAllRelationsOneByOne(ArrayList keywords) {
    
    ArrayList newKeywords = new ArrayList();
    ArrayList temp;
    int numOfKeywords = keywords.size();
    for(int i=0; i<numOfKeywords; i++) 
      {
	temp = extractor.getSynonyms((String) keywords.get(i));
	newKeywords = combine(newKeywords, temp);
      }
    
    newKeywords = combine(newKeywords, keywords);
    
    ArrayList answer = new ArrayList();
    Hashtable t = queryAllRelationsOneByOne(newKeywords);
    answer.add(t);
    answer.add(newKeywords);
    return answer;
  }
  

       private static ArrayList insertSort(ArrayList words, ArrayList scores) {
	ArrayList answer = new ArrayList();
	ArrayList tempScore = new ArrayList();
	int length = words.size();
	if(length == scores.size())
	    {
		if(length >= 0)
		    {
			answer.add(words.get(0));
			tempScore.add(scores.get(0));
		    }
		
		int i;
		int key;
		int a_i;
		Integer integ;
		Integer integ2;
		Integer integ3;
		
		if(length > 0)
		    {
			for(int j = 1; j<length; j++)
			    {
				integ = (Integer) scores.get(j);
				key = integ.intValue();
				
				for(int k=j-1; k>=0; k--)
				    {
					integ2 = (Integer) tempScore.get(k);
					if(integ2.intValue() < key)
					    {
						answer.add(k+1, words.get(j));
						tempScore.add(k+1, scores.get(j));
						break;
					    }
					else if (k==0)
					    {answer.add(k, words.get(j));
					    tempScore.add(k, scores.get(j));}
				    }
			    }
			
		    }
	    }

	int zz=answer.size();
	ArrayList reverseSort = new ArrayList();
	for(int dd=1; dd<=zz; dd++)
	  {
	    reverseSort.add(answer.get(zz-dd));
	  }
	System.out.println(tempScore);
	return reverseSort;
 }

    
  private ArrayList combine(ArrayList l1, ArrayList l2) {
    int x = l2.size();
    for (int i=0; i<x; i++) {
      l1.add(l2.get(i));
    } 
    return l1;
  }


  
}
