import java.awt.geom.*;
import javax.swing.*;
import java.awt.event.*;
import java.awt.*; 
import javax.swing.filechooser.*;
import java.io.*;
import java.util.*;
import javax.swing.event.*;


public class Gui
  extends JFrame implements ActionListener, ListSelectionListener 
{
  JDesktopPane desktop;
  final JFileChooser fc;
  Graphics2D g2;
    JTextArea input;
    Container cp;
    JPanel inputBox;
    JPanel outputBox;
    JScrollPane inputSP;
    JPanel buttonPane;
    JLabel inputFL;
    JLabel outputFL;
    JTextArea ainput;
    JScrollPane inputASP;
    JPanel abuttons;
    JLabel assocFL;
    JPanel inLeft2;
    JButton next;
    JButton prev;
    JPanel navbuttons;
    JPanel left;
    JPanel inLeft;
    JComboBox langlist;
    ButtonGroup group;
    String keyword;
    JScrollPane outputSP;
    JLabel aoutputFL;
    String[][] data;
    JPanel top;
    boolean rel = false;
    boolean phr= false;
    ButtonGroup wp;
    ArrayList filtered;
    ButtonGroup cox;
    JButton context;
    
    JTextArea output;
    Translator translator;
    Eliminator eliminator;

    private JMenuItem exitItem;
    private JMenuItem transmItem; 
    private JMenuItem assocmItem;
    private ArrayList loutput;
    private int place;
  
  ////////////////////////////
  /////// CONSTRUCTOR ////////
  ////////////////////////////


  
  /**
   * Creates the Graphical User Interface and all of its compoenets
   * It also sets up the event handler and makes sure the right
   * stuff happens at the right time. 
   **/
  public Gui() {
    super("Trans");
    eliminator = new Eliminator();
    fc = new JFileChooser();
      translator = new Translator("German");        
    //Make the big window be indented 50 pixels from each edge 
    //of the screen.
    int inset = 100;
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    setBounds(inset, inset, 
	      screenSize.width - inset, 
	      screenSize.height-inset);
    
    //Quit this app when the big window closes.
    //    getContentPane().setBackground(Color.white);
    addWindowListener(new WindowAdapter() {
	public void windowClosing(WindowEvent e) {
	  System.exit(0);//exit();
	}
      });
    
    //Set up the GUI.
    /**
 desktop = new JDesktopPane(); //a specialized layered pane
    desktop.setBackground(Color.lightGray);
        JScrollPane scrollPane = new JScrollPane(desktop);
    setContentPane(scrollPane);//setContentPane(desktop);
    **/
        
    cp = getContentPane();
    setJMenuBar(createMenuBar());
   
    input = new JTextArea();
    input.setLineWrap(true);
    input.setWrapStyleWord(true);
     inputSP = new JScrollPane(input);
    inputSP.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
    inputSP.setMaximumSize(new Dimension(1350,4750));
    inputFL = new JLabel("Please enter the text you wish to have translated:");
    inputFL.setLabelFor(inputSP);
    
    JButton clear = new JButton("Clear");
    clear.setActionCommand("clear");
    clear.addActionListener(this);
clear.setBackground(Color.white);
    JButton trans = new JButton("Translate");
    trans.setActionCommand("Translate");
    trans.addActionListener(this);
    trans.setBackground(Color.white);

    next = new JButton("Next 20");
    next.setActionCommand("next");
    next.addActionListener(this);
    next.setBackground(Color.white);
    prev = new JButton("Previous 20");
    prev.setActionCommand("prev");
    prev.addActionListener(this);
    prev.setBackground(Color.white);
    context = new JButton("Change Context");
    context.setActionCommand("ccon");
    context.addActionListener(this);
    context.setBackground(Color.white);

    navbuttons = new JPanel();
    navbuttons.setLayout(new BoxLayout(navbuttons, BoxLayout.X_AXIS));
    navbuttons.setBorder(BorderFactory.createEmptyBorder(0, 10, 10, 10));
    navbuttons.add(Box.createHorizontalGlue());
    navbuttons.add(next);
    navbuttons.add(Box.createRigidArea(new Dimension(10, 0)));
    navbuttons.setBackground(Color.white);

    buttonPane = new JPanel();
    buttonPane.setLayout(new BoxLayout(buttonPane, BoxLayout.X_AXIS));
    buttonPane.setBorder(BorderFactory.createEmptyBorder(0, 10, 10, 10));
    buttonPane.add(Box.createHorizontalGlue());
    buttonPane.add(clear);
    buttonPane.add(Box.createRigidArea(new Dimension(10, 0)));
    buttonPane.add(trans);
    buttonPane.setBackground(Color.white);

    inputBox = new JPanel();
    inputBox.setLayout(new BoxLayout(inputBox, BoxLayout.Y_AXIS));
    inputBox.add(inputFL);
    inputBox.add(Box.createRigidArea(new Dimension(0,5)));
    inputBox.add(inputSP);
    inputBox.add(Box.createRigidArea(new Dimension(0,5)));
    inputBox.add(buttonPane);
    inputBox.setBackground(Color.white);


    output = new JTextArea();
    output.setEditable(false);
    output.setLineWrap(true);
    output.setWrapStyleWord(true);
    outputSP = new JScrollPane(output);
    outputSP.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
    outputSP.setPreferredSize(new Dimension(250,250));
    outputFL = new JLabel("Here is the Translation:");
    outputFL.setLabelFor(outputSP);
    aoutputFL = new JLabel("Here are words that might relate to your situation and their translation");
    

    outputBox = new JPanel();
    outputBox.setLayout(new BoxLayout(outputBox, BoxLayout.Y_AXIS));
    outputBox.add(outputFL);
    outputBox.add(Box.createRigidArea(new Dimension(0,5)));
    outputBox.add(outputSP);
    outputBox.setBackground(Color.white);

    ainput = new JTextArea();
    ainput.setLineWrap(true);
    ainput.setWrapStyleWord(true);
    inputASP = new JScrollPane(ainput);
    inputASP.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
    inputASP.setMaximumSize(new Dimension(1300,500));
    assocFL = new JLabel("What Situation are you currently in?:");
    assocFL.setLabelFor(inputASP);
    
    JButton aclear = new JButton("Clear");
    aclear.setActionCommand("aclear");
    aclear.addActionListener(this);
aclear.setBackground(Color.white);
    JButton assoc = new JButton("Search");
    assoc.setActionCommand("Associate");
    assoc.addActionListener(this);
    assoc.setBackground(Color.white);

    JLabel worp = new JLabel("Would you like to have: ");
    JRadioButton words = new JRadioButton("relevant words?");
    words.setSelected(true);
    words.setActionCommand("words");
    words.setBackground(Color.white);
    
    JRadioButton phrase = new JRadioButton("relevant phrases?");
    phrase.setActionCommand("phrases");
    phrase.setBackground(Color.white);
    wp = new ButtonGroup();
    wp.add(words);
    wp.add(phrase);


    abuttons = new JPanel();
    abuttons.setLayout(new BoxLayout(abuttons, BoxLayout.X_AXIS));
    abuttons.setBorder(BorderFactory.createEmptyBorder(0, 10, 10, 10));
    abuttons.add(worp);
    abuttons.add(Box.createRigidArea(new Dimension(15,0)));
    abuttons.add(words);
    abuttons.add(phrase);
    abuttons.add(Box.createHorizontalGlue());
    abuttons.add(aclear);
    abuttons.add(Box.createRigidArea(new Dimension(10, 0)));
    abuttons.add(assoc);
    abuttons.setBackground(Color.white);
    
    
    JPanel textPane = new JPanel();
    textPane.setLayout(new BoxLayout(textPane, BoxLayout.Y_AXIS));
    textPane.add(inputBox);
    textPane.add(Box.createRigidArea(new Dimension(0,5)));
    textPane.add(outputBox);
    textPane.setBackground(Color.white);

    JPanel right = new JPanel();
    right.setMaximumSize(new Dimension(50,100));
    left = new JPanel();
    left.setMaximumSize(new Dimension(350,350));
    left.setLayout(new BoxLayout(left, BoxLayout.Y_AXIS));


    JLabel Lang = new JLabel("From Language");
    inLeft = new JPanel();
    inLeft.setLayout(new BoxLayout(inLeft, BoxLayout.Y_AXIS));
    inLeft.add(Lang);
    inLeft.add(Box.createRigidArea(new Dimension(0,5)));
    inLeft.setMaximumSize(new Dimension(350,50));
    inLeft.setBackground(Color.white);
    
    String[] Languages = {"English", "German", "French", "Italian", "Spanish"};
    langlist = new JComboBox(Languages);
    langlist.setSelectedIndex(0);
    langlist.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
		fromLang(e);
            }
        });
    langlist.setBackground(Color.white);

    Lang.setLabelFor(langlist);
    inLeft.add(langlist);
    left.add(inLeft);
    left.add(Box.createRigidArea(new Dimension(50, 20)));

    JLabel ToLang = new JLabel("To Language");
    inLeft2 = new JPanel();
    inLeft2.setLayout(new BoxLayout(inLeft2, BoxLayout.Y_AXIS));
    inLeft2.add(ToLang);
    inLeft2.add(Box.createRigidArea(new Dimension(0,5)));
    inLeft2.setMaximumSize(new Dimension(350,50));
inLeft2.setBackground(Color.white);    

    JComboBox tolanglist = new JComboBox(translator.translatable("English").toArray());
    tolanglist.setSelectedIndex(1);
    tolanglist.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                JComboBox cb = (JComboBox)e.getSource();
                String lang = (String)cb.getSelectedItem();
                translator.setLang(lang);
            }
        });
tolanglist.setBackground(Color.white);

    ToLang.setLabelFor(tolanglist);
    inLeft2.add(tolanglist);
    left.add(inLeft2);
    


    top = new JPanel();
    top.setLayout(new BoxLayout(top,BoxLayout.X_AXIS));
    ImageIcon firstImage = new ImageIcon("images/translation.jpg");
    JLabel picture = new JLabel(firstImage);
    ImageIcon corner = new ImageIcon("images/globe22.gif");
    JLabel cor = new JLabel(corner); 
    JPanel pic = new JPanel();
    //pic.add(picture);
    //    left.add(picture);
    top.add(cor);
    top.add(Box.createHorizontalGlue());
    top.add(picture);
    top.add(Box.createHorizontalGlue());
    top.setBackground(Color.white);
    right.setBackground(Color.white);
    left.setBackground(Color.white);
    JPanel bottom = new JPanel();
    bottom.setLayout(new BoxLayout(bottom, BoxLayout.X_AXIS));
    bottom.add(left);
    bottom.add(textPane);
    bottom.add(right);
bottom.setBackground(Color.white);
    cp.setLayout(new BoxLayout(cp, BoxLayout.Y_AXIS));
    cp.add(top);
    cp.add(Box.createRigidArea(new Dimension(10,10)));
    cp.add(bottom);
    cp.setBackground(Color.white);
        getContentPane().setBackground(Color.white);
    //Make dragging faster:
    //desktop.putClientProperty("JDesktopPane.dragMode", "outline");
    


    
    }



  
  /////////////////////////
  /////// MENU BAR ////////
  /////////////////////////
  
  
    /**
     * Creates the menubar, and all of its subcompoents It will also
     * makes ure the right thing happens when the variuous menus are
     * selected
     **/
    private JMenuBar createMenuBar() { JMenuBar menuBar =
     new JMenuBar();
    
    JMenu fileMenu = new JMenu("File");
    fileMenu.setMnemonic(KeyEvent.VK_F);


    //exit
    exitItem = new JMenuItem("Exit");
    exitItem.setMnemonic(KeyEvent.VK_X);
    exitItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_X,
						   ActionEvent.CTRL_MASK));
    exitItem.addActionListener(new ActionListener() {
	public void actionPerformed(ActionEvent e) {
	  System.exit(0);
	}
      });
    fileMenu.add(exitItem);
    menuBar.add(fileMenu);

    JMenu modeMenu = new JMenu("Mode");
    modeMenu.setMnemonic(KeyEvent.VK_M);

    //about
    transmItem = new JMenuItem("Translation Mode");
    transmItem.setMnemonic(KeyEvent.VK_T);
    transmItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_T,ActionEvent.CTRL_MASK));
    
    transmItem.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		tmode();
	    }
	});
    
    assocmItem = new JMenuItem("Association Mode");
    assocmItem.setMnemonic(KeyEvent.VK_A);
    assocmItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_A,ActionEvent.CTRL_MASK));
assocmItem.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		amode();
	    }
	});
    modeMenu.add(transmItem);
    modeMenu.add(assocmItem);
    menuBar.add(modeMenu);
    return menuBar;
  }





  ////////////////////////
  /////// METHODS ////////
  ////////////////////////


    private void amode() {
	inputBox.removeAll();
	inputBox.add(assocFL);
	inputBox.add(Box.createRigidArea(new Dimension(0,5)));
	inputBox.add(inputASP);
	inputBox.add(Box.createRigidArea(new Dimension(0,5)));
	inputBox.add(abuttons);
	inputBox.revalidate();
	left.remove(0);
	left.revalidate();
	outputBox.removeAll();
	outputBox.add(Box.createGlue());
	output.setText("");
	input.setText("");
	ImageIcon firstImage = new ImageIcon("images/association.jpg");
	JLabel picture = new JLabel(firstImage);
	ImageIcon corner = new ImageIcon("images/globe22.gif");
	JLabel cor = new JLabel(corner); 
	JPanel pic = new JPanel();
	//pic.add(picture);
	//    left.add(picture);
	top.removeAll();
	top.add(cor);
	top.add(Box.createHorizontalGlue());
	top.add(picture);
	top.add(Box.createHorizontalGlue());
	top.setBackground(Color.white);
	top.revalidate();
    }
  
    private void tmode() {
	phr = false;
	inputBox.removeAll();
	inputBox.add(inputFL);
	inputBox.add(Box.createRigidArea(new Dimension(0,5)));
	inputBox.add(inputSP);
	inputBox.add(Box.createRigidArea(new Dimension(0,5)));
	inputBox.add(buttonPane);
	inputBox.revalidate();
	ainput.setText("");
	output.setText("");
	outputBox.removeAll();
	outputBox.add(outputFL);
	outputBox.add(Box.createRigidArea(new Dimension(0,5)));
	outputBox.add(outputSP);
	outputBox.revalidate();
	left.add(inLeft,0);
	if (left.getComponentCount() == 4) {
	    left.remove(3);
	}
	left.revalidate();
	translator.setFromLang("English");
	ImageIcon firstImage = new ImageIcon("images/translation.jpg");
		JLabel picture = new JLabel(firstImage);
		ImageIcon corner = new ImageIcon("images/globe22.gif");
		JLabel cor = new JLabel(corner); 
		JPanel pic = new JPanel();
		//pic.add(picture);
		//    left.add(picture);
		top.removeAll();
		top.add(cor);
		top.add(Box.createHorizontalGlue());
		top.add(picture);
		top.add(Box.createHorizontalGlue());
		top.setBackground(Color.white);
		top.revalidate();
    }
    private void fromLang(ActionEvent e){
                JComboBox cb = (JComboBox)e.getSource();
                String lang = (String)cb.getSelectedItem();
                translator.setFromLang(lang);
		inLeft2.removeAll();
		JComboBox tolanglist = new JComboBox(translator.translatable(lang).toArray());
		tolanglist.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
			    JComboBox cb = (JComboBox)e.getSource();
			    String lang = (String)cb.getSelectedItem();
			    translator.setLang(lang);
			}
		    });
		tolanglist.setBackground(Color.white);
		inLeft2.add(tolanglist);
		inLeft2.revalidate();
	
    }

    public void actionPerformed(ActionEvent e) {
	if (e.getActionCommand().equals("clear")) {
	    input.setText("");
	}
	else if (e.getActionCommand().equals("aclear")) {
	    phr = false;
	    ainput.setText("");
	    outputBox.removeAll();
outputBox.add(Box.createGlue());
	    outputBox.revalidate();
	ImageIcon firstImage = new ImageIcon("images/association.jpg");
		JLabel picture = new JLabel(firstImage);
		ImageIcon corner = new ImageIcon("images/globe22.gif");
		JLabel cor = new JLabel(corner); 
		JPanel pic = new JPanel();
		//pic.add(picture);
		//    left.add(picture);
		top.removeAll();
		top.add(cor);
		top.add(Box.createHorizontalGlue());
		top.add(picture);
		top.add(Box.createHorizontalGlue());
		top.setBackground(Color.white);
		top.revalidate();
	    
	}
	else if (e.getActionCommand().equals("Translate")) {
	    String s = input.getText();
	    if(!(s.equals(""))) {
		s = translator.translate(s);
		output.setText(s);
	    }

	}
	else if (e.getActionCommand().equals("Associate")) {
	    if (!(ainput.getText().equals(""))){
		ButtonModel bm = wp.getSelection();
		if (bm.getActionCommand().equals("words")) {
		    phr = false;
		    associate(ainput.getText());
		}
		else {
		    phr = true;
		    phrase(ainput.getText());
		}
	    }
	}
	else if (e.getActionCommand().equals("ccon")){
	    ask();
	}
	else if (e.getActionCommand().equals("next")){
	    nextdisp();
	}
	else if (e.getActionCommand().equals("prev")) {
	    prevdisp();
	}
	else if (e.getActionCommand().equals("go")){
	    ButtonModel bm = group.getSelection();
	    GetWords2 gwords = new GetWords2();
	    ArrayList outrel;
	    if (bm.getActionCommand().equals("syn")) {
		outrel= gwords.getSynonyms(keyword);
	    }
	    else if (bm.getActionCommand().substring(0,1).equals("S")) {
		ArrayList key = new ArrayList();
		key.add(keyword);
		outrel = gwords.queryRelationWithSource(key, bm.getActionCommand().substring(1));
	    }
	    else {
		ArrayList key = new ArrayList();
		key.add(keyword);
		outrel = gwords.queryRelationWithTarget(key, bm.getActionCommand().substring(1));
	    }
	    ArrayList trans = gwords.translate(outrel,"English", translator.getToLang(),0);
	    createTable(outrel,trans);
	    
	    JButton back = new JButton("back");
	    back.setActionCommand("back");
	    back.addActionListener(this);
	    back.setBackground(Color.white);
	    JPanel backb = new JPanel();
	    backb.add(back);
	    backb.setBackground(Color.white);
	    outputBox.add(backb);
	    outputBox.revalidate();
	}
	else if (e.getActionCommand().equals("back")){
	    rel = false;
	    GetWords2 gword = new GetWords2();
	    ArrayList trans = gword.translate(loutput, "English", translator.getToLang(),0);
	    createTable(loutput,trans);
	}
	else if (e.getActionCommand().equals("pgo")){
	    System.out.println("foo");
	     ButtonModel bm = cox.getSelection();
	    getp(bm.getActionCommand());
	}
	else {
	}
    }

    private void associate(String in) {
	if (rel) 
	    rel = false;
	StringTokenizer toks = new StringTokenizer(in," ", false);
	ArrayList sarr = new ArrayList();
	while (toks.hasMoreTokens()) {
	    sarr.add(toks.nextToken());
	}
	filtered = eliminator.eliminate(sarr);
	PhotoSelector psel = new PhotoSelector();
	ImageIcon firstImage = new ImageIcon("images/association.jpg");
	JLabel picture = new JLabel(firstImage);
	String filename = psel.getPhoto(filtered);
	ImageIcon corner = new ImageIcon("images/" + filename);
	JLabel cor = new JLabel(corner); 
	JPanel pic = new JPanel();
	//pic.add(picture);
	//    left.add(picture);
	top.removeAll();
	top.add(cor);
	top.add(Box.createHorizontalGlue());
	top.add(picture);
	top.add(Box.createHorizontalGlue());
	top.setBackground(Color.white);
	top.revalidate();
	GetWords2 gword = new GetWords2();
	loutput = gword.queryAllRelations(filtered);
	ArrayList eng = loutput;
	ArrayList trans = gword.translate(loutput, "English", translator.getToLang(),0);
	createTable(eng,trans);

	String[] keys = new String[filtered.size()];
	for (int i =0; i < filtered.size(); i++) {
	    keys[i] = (String)filtered.get(i);
	}
	JList keyw = new JList(keys);
	keyw.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        keyw.addListSelectionListener(this);
        JScrollPane listScrollPane = new JScrollPane(keyw);
		if (left.getComponentCount() == 3) {
	  left.remove(2);
	}
	left.add(listScrollPane);
	left.revalidate();
    }

    public void valueChanged(ListSelectionEvent e) {
        if (e.getValueIsAdjusting())
            return;

        JList theList = (JList)e.getSource();
        if (theList.isSelectionEmpty()) {
	} 
	else {
	    keyword = (String)theList.getSelectedValue();
	    rels();
        }
    }

	private void nextdisp() {
	    navbuttons.add(prev,0);
	    int m = 20;
	    int k = place/20 + 1;
	    if ((loutput.size() - place)< 20) {
		m = loutput.size() - place;
	    }
	    if (!(m == 0)){
	    GetWords2 gword = new GetWords2();
	    ArrayList trans = gword.translate(loutput, "English", translator.getToLang(),k);
	    ArrayList eng = gword.translatedList(loutput,k);
	    place = place + 20;
	    createTable(eng,trans);
	    }
	}
    private void prevdisp() {
	    navbuttons.add(prev,0);
	    int m = 20;
	    if (!(place == 0)) {
		int k = place/20 - 1;
		if ((loutput.size() - place)<20) {
		    m = loutput.size() - place;
		}
		GetWords2 gword = new GetWords2();
		ArrayList trans = gword.translate(loutput, "English", translator.getToLang(),k);
		ArrayList eng = gword.translatedList(loutput,k);
		place = place - 20;
		createTable(eng,trans);

	    }
	}

    private void phrase(String in) {
	if (rel) {
	    rel = false;
	}
	StringTokenizer toks = new StringTokenizer(in," ", false);
	ArrayList sarr = new ArrayList();
	while (toks.hasMoreTokens()) {
	    sarr.add(toks.nextToken());
	}
	filtered = eliminator.eliminate(sarr);
	PhotoSelector psel = new PhotoSelector();
	ImageIcon firstImage = new ImageIcon("images/association.jpg");
	JLabel picture = new JLabel(firstImage);
	String filename = psel.getPhoto(filtered);
	ImageIcon corner = new ImageIcon("images/" + filename);
	JLabel cor = new JLabel(corner); 
	JPanel pic = new JPanel();
	//pic.add(picture);
	//    left.add(picture);
	top.removeAll();
	top.add(cor);
	top.add(Box.createHorizontalGlue());
	top.add(picture);
	top.add(Box.createHorizontalGlue());
	top.setBackground(Color.white);
	top.revalidate();
	GuessContext gc = new GuessContext();
	String c = gc.guess(filtered);
	if (c.equals("Other")) {
	    ask();
	}
	else {
	    getp(c);
	}
    }
    private void getp(String c) {
	GetPhrases gp = new GetPhrases();
	loutput = gp.queryForPhrases(filtered,c);
	ArrayList trans = gp.translate(loutput, "English",translator.getToLang(),0);
	phr = true;
	createTable(loutput,trans);
    }

    private void ask() {
	JLabel ins = new JLabel("I could not figure out the context. Please choose from the list below:");
	JRadioButton acc = new JRadioButton("Accomodation");
	acc.setSelected(true);
	acc.setActionCommand("Accomodations");
	acc.setBackground(Color.white);
	JRadioButton food = new JRadioButton("Food and Dining");
	food.setActionCommand("Food & Dining");
	food.setBackground(Color.white);
	JRadioButton trav = new JRadioButton("Travel and Transportation");
	trav.setActionCommand("Travel & Transportation");
	trav.setBackground(Color.white);
	JRadioButton hs = new JRadioButton("Health and Safety");
	hs.setActionCommand("Health & Safety");
	hs.setBackground(Color.white);
	JRadioButton lei = new JRadioButton("Leisure");
	lei.setActionCommand("Leisure");
	lei.setBackground(Color.white);
	JRadioButton ser = new JRadioButton("Services");
	ser.setActionCommand("Services");
	ser.setBackground(Color.white);
	JRadioButton shop = new JRadioButton("Shopping");
	shop.setActionCommand("Shopping");
	shop.setBackground(Color.white);
	JRadioButton em = new JRadioButton("Emergency");
	em.setActionCommand("Emergency");
	em.setBackground(Color.white);
	JRadioButton oth = new JRadioButton("Other");
	oth.setActionCommand("Other");
	oth.setBackground(Color.white);
	cox = new ButtonGroup();
	cox.add(acc);
	cox.add(food);
	cox.add(oth);
	cox.add(trav);
	cox.add(hs);
	cox.add(ser);
	cox.add(shop);
	cox.add(em);
	cox.add(lei);
	JPanel conts = new JPanel();	    
	conts.setLayout(new BoxLayout(conts, BoxLayout.Y_AXIS));
	conts.add(ins);
	conts.add(Box.createRigidArea(new Dimension(20,20)));
	conts.add(acc); 
	conts.add(food); 
	conts.add(trav);
	conts.add(hs);
	conts.add(ser);
	conts.add(shop);
	conts.add(em);
	conts.add(lei);
	conts.add(oth);
	conts.setBackground(Color.white);
	JPanel mid = new JPanel();
	mid.setLayout(new BoxLayout(mid, BoxLayout.X_AXIS));
	mid.add(Box.createHorizontalGlue());
	mid.add(conts);
	mid.add(Box.createHorizontalGlue());
	JButton gos = new JButton("Go");
	gos.setActionCommand("pgo");
	gos.setBackground(Color.white);
	gos.addActionListener(this);
	JPanel gobut = new JPanel();
	gobut.setLayout(new BoxLayout(gobut, BoxLayout.X_AXIS));
	gobut.add(Box.createHorizontalGlue());
	gobut.add(gos);
	gobut.add(Box.createHorizontalGlue());
	gobut.setBackground(Color.white);
	mid.setBackground(Color.white);
	JPanel out = new JPanel();
	out.setLayout(new BoxLayout(out, BoxLayout.Y_AXIS));
	out.add(Box.createVerticalGlue());
	out.add(mid);
	out.add(Box.createVerticalGlue());
	out.add(gobut);
	out.add(Box.createVerticalGlue());
	out.setBackground(Color.white);
	outputBox.removeAll();
	outputBox.add(out);
	outputBox.revalidate();
    }

    private void createTable(ArrayList eng, ArrayList trans) {
	int m = 20;
	if (eng.size() < 20) {
	    m = eng.size();
	}
	data = new String[m][2];
	for (int i = 0; i < m; i++) {
	    data[i][0] = (String)eng.get(i);
	    data[i][1] = (String)trans.get(i);
	}
	String[] Names = {"English", "Translation"};
	final JTable table = new JTable(data, Names);
	table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
	ListSelectionModel rowSM = table.getSelectionModel();
	rowSM.addListSelectionListener(new ListSelectionListener() {
                public void valueChanged(ListSelectionEvent e) {
                    //Ignore extra messages.
                    if (e.getValueIsAdjusting()) return;
                    
                    ListSelectionModel lsm =
                        (ListSelectionModel)e.getSource();
		    if (!phr) {
			if (lsm.isSelectionEmpty()) {
			} else {
			    int selectedRow = lsm.getMinSelectionIndex();
			    keyword = data[selectedRow][0];
			    rels();
			}
		    }
                }
            });
	JScrollPane scrollPane = new JScrollPane(table);
	table.setPreferredScrollableViewportSize(new Dimension(400, 70));
	table.setBackground(Color.white);	
	scrollPane.setBackground(Color.white);
	outputBox.removeAll();
	outputBox.add(outputFL);
	outputBox.add(Box.createRigidArea(new Dimension(0,5)));
	outputBox.add(scrollPane);
	if (!rel) {
	    if (phr) {
		if (navbuttons.getComponentCount() ==3) {
		    navbuttons.add(context,1);
		}
		else {
		    navbuttons.add(context,2);
		}
	    }
	    outputBox.add(navbuttons);
	    
	}
	outputBox.revalidate();
    }


    private void rels() {
	rel = true;
	String loc = "HASLOCATION";
	String eff = "HASEFFECT";
	String ab = "HASABILITY";
	//String coll = "HASCOLLOCATE";
	String mot = "HASMOTIVATION";
	String ptype = "HASPARENTTYPE";
	String part = "HASPART";
	String req = "HASREQUIREMENT";
	String rwant = "HASRESULTINGWANT";
	String step = "HASSTEP";
	String uwant = "HASUNWANT";
	String use = "HASUSE";
	String useloc = "HASUSELOCATION";
	String want = "HASWANT";
	
	JLabel inst = new JLabel("Please choose the relation you would like to have expanded for " + keyword + ".");
	JLabel inst3 = new JLabel("Words in capital letters are just example words, which would be replaced by " + keyword + " in the query.");
	JRadioButton synon = new JRadioButton("1. Synonyms of " + keyword);
	synon.setSelected(true);
	synon.setActionCommand("syn");
	synon.setBackground(Color.white);
	JLabel lo = new JLabel("Location:");
	JRadioButton Slocat = new JRadioButton("<html><font size = 2>2. Where can you find FOOD? Restaurant </font>");
	Slocat.setActionCommand("S" + loc);
	Slocat.setBackground(Color.white);
	JRadioButton Tlocat = new JRadioButton("<html><font size = 2>3. What can you find at a RESTAURANT? Food, ...</font>");
	Tlocat.setActionCommand("T" + loc);
	Tlocat.setBackground(Color.white);
	JLabel effe = new JLabel("Effects:");
	JRadioButton Seffects = new JRadioButton("<html> <font size = 2>4.What is the effect of LOVE? To become distracted,...</font>"); 
	Seffects.setActionCommand("S" + eff);
	Seffects.setBackground(Color.white);
	JRadioButton Teffects = new JRadioButton("<html> <font size = 2>5.Of what is EATING the consequence? Cooking,...</font>");
	Teffects.setActionCommand("T" + eff);
	Teffects.setBackground(Color.white);
	JLabel abi = new JLabel("Ability:");
	JRadioButton Sabil = new JRadioButton("<html><font size = 2>6.What can a WAITER do? Serving food, ...</font>");
	Sabil.setActionCommand("S" + ab);
	Sabil.setBackground(Color.white);
	JRadioButton Tabil = new JRadioButton("<html><font size = 2>7. What/Who has the ability to SERVE FOOD? A waiter, ...</font>");
	Tabil.setActionCommand("T" + ab);
	Tabil.setBackground(Color.white);
	JLabel moti = new JLabel("Motivation:");
	JRadioButton Smotiv = new JRadioButton("<html><font size = 2>8. What does a PRISONER want? Escape, ...</font>");
	Smotiv.setActionCommand("S" + mot);
	Smotiv.setBackground(Color.white);
	JRadioButton Tmotiv = new JRadioButton("<html><font size = 2>9. What is EATING motivated by? Hunger, ...</font>");
	Tmotiv.setActionCommand("T" + mot);
	Tmotiv.setBackground(Color.white);
	JLabel pt = new JLabel("General and Specific:");
	JRadioButton Spt = new JRadioButton("<html><font size = 2>10. What are subclasses of DOG? Golden Retriever, ...</font>");
	Spt.setActionCommand("S" + ptype);
	Spt.setBackground(Color.white);
	JRadioButton Tpt = new JRadioButton("<html><font size = 2>11. What are the more generic terms of DOG? Animal, ...</font>");
	Tpt.setActionCommand("T" + ptype);
	Tpt.setBackground(Color.white);
	JLabel pr = new JLabel("Parts:");
	JRadioButton Spr = new JRadioButton("<html><font size = 2>12. Into what parts can you divide CANADA? Alberta, Yukon, ...</font>");
	Spr.setActionCommand("S" + part);
	Spr.setBackground(Color.white);
	JRadioButton Tpr = new JRadioButton("<html><font size = 2>13. What is CANADA a part of? North America, ...</font>");
	Tpr.setActionCommand("T" + part);
	Tpr.setBackground(Color.white);
	JLabel reqs = new JLabel("Requirements:");
	JRadioButton Sreqs = new JRadioButton("<html><font size = 2>14. What are the requirement for EATING? Food, ...</font>");
	Sreqs.setActionCommand("S" + req);
	Sreqs.setBackground(Color.white);
	JRadioButton Treqs = new JRadioButton("<html><font size = 2>15. For what is EATING a requirement? Diminishing hunger, ...</font>");
	Treqs.setActionCommand("T" + req);
	Treqs.setBackground(Color.white);
	JLabel resw = new JLabel("Goals:");
	JRadioButton Sresw = new JRadioButton("<html><font size = 2>16. What are the goals of a LAWYER? Taking the stand, ...</font>");
	Sresw.setActionCommand("S" + rwant);
	Sresw.setBackground(Color.white);
	JRadioButton Tresw = new JRadioButton("<html><font size = 2>17. What results in EATING? Feeling hunger, ...</font>");
	Tresw.setActionCommand("T" + rwant);
	Tresw.setBackground(Color.white);
	JLabel st = new JLabel("What's involved:");
	JRadioButton Sst = new JRadioButton("<html><font size = 2>18. What does EATING imply? Chew food, Use knife, ...</font>");
	Sst.setActionCommand("S" + step);
	Sst.setBackground(Color.white);
	JRadioButton Tst = new JRadioButton("<html><font size = 2>19. What includes and/or involves FOOD? Eating,...</font>");
	Tst.setActionCommand("T" + step);
	Tst.setBackground(Color.white);
	JLabel uw = new JLabel("What's not wanted:");
	JRadioButton Suw = new JRadioButton("<html><font size = 2>20. What does a WAITER not want? Getting no tipes, ...</font>");
	Suw.setActionCommand("S" + uwant);
	Suw.setBackground(Color.white);
	JRadioButton Tuw = new JRadioButton("<html><font size = 2>21. What/who does not want to EAT? A sick person, ...</font>");
	Tuw.setActionCommand("T" + uwant);
	Tuw.setBackground(Color.white);
	JLabel uses = new JLabel("What's used:");
	JRadioButton Suses = new JRadioButton("<html><font size = 2>22. What is used for SLEEPING? Bed, ...</font>");
	Suses.setActionCommand("S" + use);
	Suses.setBackground(Color.white);
	JRadioButton Tuses = new JRadioButton("<html><font size = 2>23. What's the use of a HOUSE? Shelter, ...</font>");
	Tuses.setActionCommand("T" + use);
	Tuses.setBackground(Color.white);
	JLabel usel = new JLabel("Locations of uses:");
	JRadioButton Susel = new JRadioButton("<html><font size = 2>24. Where is a FORK used? Restaurant, ...</font>");
	Susel.setActionCommand("S" + useloc);
	Susel.setBackground(Color.white);
	JRadioButton Tusel = new JRadioButton("<html><font size = 2>25. What is used in a RESTAURANT? Place, ...</font>");
	Tusel.setActionCommand("T" + useloc);
	Tusel.setBackground(Color.white);
	JLabel des = new JLabel("Desires:");
	JRadioButton Sdes = new JRadioButton("<html><font size = 2>26. What does a WAITER want? Tips, ...</font>");
	Sdes.setActionCommand("S" + want);
	Sdes.setBackground(Color.white);
	JRadioButton Tdes = new JRadioButton("<html><font size = 2>27. Who wants to EAT? A hungry person, ...</font>");
	Tdes.setActionCommand("T" + want);
	Tdes.setBackground(Color.white);
	group = new ButtonGroup();
	group.add(synon);
	group.add(Slocat);
	group.add(Seffects);
	group.add(Tlocat);
	group.add(Teffects);
	group.add(Sabil);
	group.add(Tabil);
	group.add(Smotiv);
	group.add(Tmotiv);
	group.add(Spt);
	group.add(Tpt);
	group.add(Spr);
	group.add(Tpr);
	group.add(Sreqs);
	group.add(Treqs);
	group.add(Sresw);
	group.add(Tresw);
	group.add(Sst);
	group.add(Tst);
	group.add(Suw);
	group.add(Tuw);
	group.add(Suses);
	group.add(Tuses);
	group.add(Susel);
	group.add(Tusel);
	group.add(Sdes);
	group.add(Tdes);
	JPanel radioPanel = new JPanel();
	radioPanel.setLayout(new BoxLayout(radioPanel, BoxLayout.Y_AXIS));
	JPanel lradioPanel = new JPanel();	    
	lradioPanel.setLayout(new BoxLayout(lradioPanel, BoxLayout.Y_AXIS));
	lradioPanel.add(synon); 
	lradioPanel.add(lo);
	lradioPanel.add(Slocat);
	lradioPanel.add(Tlocat);
	lradioPanel.add(effe);
	lradioPanel.add(Seffects);
	lradioPanel.add(Teffects);
	lradioPanel.add(abi);
	lradioPanel.add(Sabil);
	lradioPanel.add(Tabil);
	lradioPanel.add(moti);
	lradioPanel.add(Smotiv);
	lradioPanel.add(Tmotiv);
	lradioPanel.add(pt);
	lradioPanel.add(Spt);
	lradioPanel.add(Tpt);
	lradioPanel.add(pr);
	lradioPanel.add(Spr);
	lradioPanel.add(Tpr);
	lradioPanel.setBackground(Color.white);
	JPanel rradioPanel = new JPanel();
	rradioPanel.setLayout(new BoxLayout(rradioPanel, BoxLayout.Y_AXIS));
	rradioPanel.add(reqs);
	rradioPanel.add(Sreqs);
	rradioPanel.add(Treqs);	    
	
	rradioPanel.add(resw);
	rradioPanel.add(Sresw);
	rradioPanel.add(Tresw);
	rradioPanel.add(st);
	rradioPanel.add(Sst);
	rradioPanel.add(Tst);
	rradioPanel.add(uw);
	rradioPanel.add(Suw);
	rradioPanel.add(Tuw);
	rradioPanel.add(uses);
	rradioPanel.add(Suses);
	rradioPanel.add(Tuses);
	rradioPanel.add(usel);
	rradioPanel.add(Susel);
	rradioPanel.add(Tusel);
	rradioPanel.add(des);
	rradioPanel.add(Sdes);
	rradioPanel.add(Tdes);
	rradioPanel.setBackground(Color.white);
	JPanel pradio = new JPanel();
	pradio.setLayout(new BoxLayout(pradio, BoxLayout.X_AXIS));	   
	pradio.add(Box.createRigidArea(new Dimension(30, 0)));
	pradio.add(lradioPanel);
	pradio.add(rradioPanel);
	pradio.setBackground(Color.white);
	JPanel instr = new JPanel();
	instr.setLayout(new BoxLayout(instr, BoxLayout.Y_AXIS));
	instr.add(inst);
	instr.add(inst3);
	instr.setBackground(Color.white);
	JPanel iP = new JPanel();
	iP.setLayout(new BoxLayout(iP, BoxLayout.X_AXIS));
	iP.add(instr);
	iP.add(Box.createHorizontalGlue());
	iP.setBackground(Color.white);
	radioPanel.add(iP);
	radioPanel.add(Box.createRigidArea(new Dimension(20,10)));
	radioPanel.add(pradio);
	radioPanel.setBackground(Color.white);
	JButton go = new JButton("Go!");
	JButton back = new JButton("Back");
	go.setBackground(Color.white);
	back.setBackground(Color.white);
	go.setActionCommand("go");
	go.addActionListener(this);
	back.setActionCommand("back");
	back.addActionListener(this);
	JPanel goButton = new JPanel();
	goButton.add(go);
	goButton.add(back);
	goButton.setBackground(Color.white);
	outputBox.removeAll();
	outputBox.add(Box.createGlue());
	outputBox.add(radioPanel);
	outputBox.add(goButton);
	outputBox.add(Box.createGlue());
	outputBox.revalidate();
    }



	
  ///////////////////////
  //////// MAIN /////////
  ///////////////////////
  
  
  /**
   * Main method
   * Short, but cute
   **/
  public static void main(String[] args) {
    Gui frame = new Gui();
    frame.setVisible(true);
    
  }
}

