import java.util.*;
import java.net.*;
import java.io.*;
import javax.swing.text.*; 
import java.lang.*;
import javax.swing.text.html.*;
import javax.swing.text.html.parser.*;

public class OMCNet {

  private ArrayList relations;

  public OMCNet() {
    relations = getRelations();
  }
  
  
  public ArrayList getRelations() {    
    //Returns an ArrayList of the relations currently in the OMCNet.
    ArrayList output = new ArrayList();
    
    try 
      {
	//Contruct URL for OMCNet Web Interface
	URL source = new URL("http://taffy.media.mit.edu/cgi-bin/omcsnet-get.cgi?info=1");
	
	//Connect to OMCNet web interface.
	OnlineConnection service_connection = new OnlineConnection(source);
	
	// Obtain content of target.  
	//	HTMLDocument document = new HTMLDocument();
	InputStream input;
	
	String line;
	
	try
	  {
	    Object o = source.getContent();
	    
	    input = (InputStream) o;
	    InputStreamReader isr = new InputStreamReader( input );
	    BufferedReader in = new BufferedReader( isr );
	    while ( (line = in.readLine() ) != null )
	      {
		if (!(line.equals("--- RELATIONS RESULTS ---")) && !(line.equals("--- END OF RESULTS ---")) && !(line.equals("")))
		  {
		    //System.out.println(line);
		    output.add(line);
		  }
 	      }
	    in.close();	    
	  }
	catch(IOException e)
	  {
	    System.err.println("ERROR 1: Something went wrong.\n" + e);	
	  }
      }
    catch(MalformedURLException e)
      {
	System.err.println("ERROR 3: Something went wrong.\n" + e);	
      }
    return output;
  }
  


  public String getRelationsString() {    
    //Returns a space delimited String of the relations currently in
    //the OMCNet.
    String output = "";
    
    try 
      {
	//Contruct URL for OMCNet Web Interface
	URL source = new URL("http://taffy.media.mit.edu/cgi-bin/omcsnet-get.cgi?info=1");
	
	//Connect to OMCNet web interface.
	OnlineConnection service_connection = new OnlineConnection(source);
	
	// Obtain content of target.  
	//	HTMLDocument document = new HTMLDocument();
	InputStream input;
	
	String line;
	
	try
	  {
	    Object o = source.getContent();
	    
	    input = (InputStream) o;
	    InputStreamReader isr = new InputStreamReader( input );
	    BufferedReader in = new BufferedReader( isr );
	    String relationsString = "";
	    while ( (line = in.readLine() ) != null )
	      {
		if (!(line.equals("--- RELATIONS RESULTS ---")) && !(line.equals("--- END OF RESULTS ---")) && !(line.equals("")))
		  {		
		    relationsString = relationsString + line + " ";
		    output = relationsString;
		  }
 	      }
	    in.close();	    
	  }
	catch(IOException e)
	  {
	    System.err.println("ERROR 1: Something went wrong.\n" + e);	
	  }
      }
    catch(MalformedURLException e)
      {
	System.err.println("ERROR 3: Something went wrong.\n" + e);	
      }
    
    return output;
  }


  public ArrayList getSynonyms(String word) {
    //returns an ArrayList of the sysnonyms of word.

    ArrayList output = new ArrayList();
    
    try 
      {
	//Contruct URL for OMCNet Web Interface
	URL source = new URL("http://taffy.media.mit.edu/cgi-bin/omcsnet-get.cgi?synonyms=" + word);
	
	//Connect to OMCNet web interface.
	OnlineConnection service_connection = new OnlineConnection(source);
	
	// Obtain content of target.  
	//	HTMLDocument document = new HTMLDocument();
	InputStream input;
	
	String line;
	
	try
	  {
	    Object o = source.getContent();
	    
	    input = (InputStream) o;
	    InputStreamReader isr = new InputStreamReader( input );
	    BufferedReader in = new BufferedReader( isr );
	    while ( (line = in.readLine() ) != null )
	      {
		if (!(line.equals("--- SYNONYM RESULTS ---")) && !(line.equals("--- END OF RESULTS ---")) && !(line.equals("")))
		  {
		    output.add(line);
		  }
 	      }
	    in.close();	    
	  }
	catch(IOException e)
	  {
	    System.err.println("ERROR 1: Something went wrong.\n" + e);	
	  }
      }
    catch(MalformedURLException e)
      {
	System.err.println("ERROR 3: Something went wrong.\n" + e);	
      }
    return output;
  }



  public ArrayList getWordsWithSource(String word, String reln) {    
    //returns the words which word points to in the relations reln.

    ArrayList output = new ArrayList();
    
    try 
      {
	//Contruct URL for OMCNet Web Interface
	URL source = new URL("http://taffy.media.mit.edu/cgi-bin/omcsnet-get.cgi?source=" + word + "&relation=" + reln);
	
	//Connect to OMCNet web interface.
	OnlineConnection service_connection = new OnlineConnection(source);
	
	// Obtain content of target.  
	//	HTMLDocument document = new HTMLDocument();
	InputStream input;
	
	String line;
	
	try
	  {
	    Object o = source.getContent();
	    
	    input = (InputStream) o;
	    InputStreamReader isr = new InputStreamReader( input );
	    BufferedReader in = new BufferedReader( isr );
	    while ( (line = in.readLine() ) != null )
	      {
		if (!(line.equals("--- TARGET RESULTS ---")) && !(line.equals("--- END OF RESULTS ---")) && !(line.equals("")))
		  {
		    output.add(line);
		  }
 	      }
	    in.close();	    
	  }
	catch(IOException e)
	  {
	    System.err.println("ERROR 1: Something went wrong.\n" + e);	
	  }
      }
    catch(MalformedURLException e)
      {
	System.err.println("ERROR 3: Something went wrong.\n" + e);	
      }
    return output;
  }


 public ArrayList getWordsWithSource(String word) {    
    //returns the words which word points to in all relations.

    ArrayList output = new ArrayList();
    
    try 
      {
	//Contruct URL for OMCNet Web Interface
	URL source = new URL("http://taffy.media.mit.edu/cgi-bin/omcsnet-get.cgi?source=" + word);
	
	//Connect to OMCNet web interface.
	OnlineConnection service_connection = new OnlineConnection(source);
	
	// Obtain content of target.  
	//	HTMLDocument document = new HTMLDocument();
	InputStream input;
	
	String line;
	
	try
	  {
	    Object o = source.getContent();
	    
	    input = (InputStream) o;
	    InputStreamReader isr = new InputStreamReader( input );
	    BufferedReader in = new BufferedReader( isr );
	    while ( (line = in.readLine() ) != null )
	      {
		if (!(line.equals("--- TARGET RESULTS ---")) && !(line.equals("--- END OF RESULTS ---")) && !(line.equals("")))
		  {
		    output.add(line);
		  }
 	      }
	    in.close();	    
	  }
	catch(IOException e)
	  {
	    System.err.println("ERROR 1: Something went wrong.\n" + e);	
	  }
      }
    catch(MalformedURLException e)
      {
	System.err.println("ERROR 3: Something went wrong.\n" + e);	
      }
    return output;
  }






  public ArrayList getWordsWithTarget(String word) {  
    //returns the words that point to word in all relations

    ArrayList output = new ArrayList();
    
    try 
      {
	//Contruct URL for OMCNet Web Interface
	URL source = new URL("http://taffy.media.mit.edu/cgi-bin/omcsnet-get.cgi?target=" + word);
	
	//Connect to OMCNet web interface.
	OnlineConnection service_connection = new OnlineConnection(source);
	
	// Obtain content of target.  
	//	HTMLDocument document = new HTMLDocument();
	InputStream input;
	
	String line;
	
	try
	  {
	    Object o = source.getContent();
	    
	    input = (InputStream) o;
	    InputStreamReader isr = new InputStreamReader( input );
	    BufferedReader in = new BufferedReader( isr );
	    while ( (line = in.readLine() ) != null )
	      {
		if (!(line.equals("--- SOURCE RESULTS ---")) && !(line.equals("--- END OF RESULTS ---")) && !(line.equals("")))
		  {
		    output.add(line);
		  }
 	      }
	    in.close();	    
	  }
	catch(IOException e)
	  {
	    System.err.println("ERROR 1: Something went wrong.\n" + e);	
	  }
      }
    catch(MalformedURLException e)
      {
	System.err.println("ERROR 3: Something went wrong.\n" + e);	
      }
    return output;
  }



  public ArrayList getWordsWithTarget(String word, String reln) {  
    //returns the words that point to word in the relation reln.

    ArrayList output = new ArrayList();
    
    try 
      {
	//Contruct URL for OMCNet Web Interface
	URL source = new URL("http://taffy.media.mit.edu/cgi-bin/omcsnet-get.cgi?target=" + word + "&relation=" + reln);
	
	//Connect to OMCNet web interface.
	OnlineConnection service_connection = new OnlineConnection(source);
	
	// Obtain content of target.  
	//	HTMLDocument document = new HTMLDocument();
	InputStream input;
	
	String line;
	
	try
	  {
	    Object o = source.getContent();
	    
	    input = (InputStream) o;
	    InputStreamReader isr = new InputStreamReader( input );
	    BufferedReader in = new BufferedReader( isr );
	    while ( (line = in.readLine() ) != null )
	      {
		if (!(line.equals("--- SOURCE RESULTS ---")) && !(line.equals("--- END OF RESULTS ---")) && !(line.equals("")))
		  {
		    output.add(line);
		  }
 	      }
	    in.close();	    
	  }
	catch(IOException e)
	  {
	    System.err.println("ERROR 1: Something went wrong.\n" + e);	
	  }
      }
    catch(MalformedURLException e)
      {
	System.err.println("ERROR 3: Something went wrong.\n" + e);	
      }
    return output;
  }











  public ArrayList expandWord(String word) {    
    //expands on the word word and returns all the sentences/nodes
    //that contain it.

    ArrayList output = new ArrayList();
    
    try 
      {
	//Contruct URL for OMCNet Web Interface
	URL source = new URL("http://http://taffy.media.mit.edu/cgi-bin/omcsnet-get.cgi?term=" + word);
	
	//Connect to OMCNet web interface.
	OnlineConnection service_connection = new OnlineConnection(source);
	
	// Obtain content of target.  
	//	HTMLDocument document = new HTMLDocument();
	InputStream input;
	
	String line;
	
	try
	  {
	    Object o = source.getContent();
	    
	    input = (InputStream) o;
	    InputStreamReader isr = new InputStreamReader( input );
	    BufferedReader in = new BufferedReader( isr );
	    while ( (line = in.readLine() ) != null )
	      {
		if (!(line.equals("--- TERM EXPANSION RESULTS ---")) && !(line.equals("--- END OF RESULTS ---")) && !(line.equals("")))
		  {
		    output.add(line);
		  }
 	      }
	    in.close();	    
	  }
	catch(IOException e)
	  {
	    System.err.println("ERROR 1: Something went wrong.\n" + e);	
	  }
      }
    catch(MalformedURLException e)
      {
	System.err.println("ERROR 3: Something went wrong.\n" + e);	
      }
    return output;
  }


  public ArrayList source_Expansion (String word, String rln) {    
    //returns all the words that all the expansion of word point to
    //with relation rln.
    //
    //For all relations enter "" for rln.

    ArrayList output = new ArrayList();
    
    try 
      {
	//Contruct URL for OMCNet Web Interface
	URL source = new URL("http://taffy.media.mit.edu/cgi-bin/omcsnet-get.cgi?source=" + word + "&relation=" + rln + "&expand=1");

	if(rln.equals("")) 
	  {
	    source = new URL("http://taffy.media.mit.edu/cgi-bin/omcsnet-get.cgi?source=" + word + "&expand=1");
	  }

	//Connect to OMCNet web interface.
	OnlineConnection service_connection = new OnlineConnection(source);
	
	// Obtain content of target.  
	//	HTMLDocument document = new HTMLDocument();
	InputStream input;
	
	String line;
	
	try
	  {
	    Object o = source.getContent();
	    
	    input = (InputStream) o;
	    InputStreamReader isr = new InputStreamReader( input );
	    BufferedReader in = new BufferedReader( isr );
	    while ( (line = in.readLine() ) != null )
	      {
		if (!(line.equals("--- TARGET RESULTS ---")) && !(line.equals("--- END OF RESULTS ---")) && !(line.equals("")))
		  {
		    output.add(line);
		  }
 	      }
	    in.close();	    
	  }
	catch(IOException e)
	  {
	    System.err.println("ERROR 1: Something went wrong.\n" + e);	
	  }
      }
    catch(MalformedURLException e)
      {
	System.err.println("ERROR 3: Something went wrong.\n" + e);	
      }
    return output;
  }




  public ArrayList target_Expansion (String word, String rln) {    
    //returns all the words that point to all the expansion of word
    //with relation rln.
    //
    //For all relations enter "" for rln.

    ArrayList output = new ArrayList();
    
    try 
      {
	//Contruct URL for OMCNet Web Interface
	URL source = new URL("http://taffy.media.mit.edu/cgi-bin/omcsnet-get.cgi?target=" + word + "&relation=" + rln + "&expand=1");

	if(rln.equals("")) 
	  {
	    source = new URL("http://taffy.media.mit.edu/cgi-bin/omcsnet-get.cgi?target=" + word + "&expand=1");
	  }


	//Connect to OMCNet web interface.
	OnlineConnection service_connection = new OnlineConnection(source);
	
	// Obtain content of target.  
	//	HTMLDocument document = new HTMLDocument();
	InputStream input;
	
	String line;
	
	try
	  {
	    Object o = source.getContent();
	    
	    input = (InputStream) o;
	    InputStreamReader isr = new InputStreamReader( input );
	    BufferedReader in = new BufferedReader( isr );
	    while ( (line = in.readLine() ) != null )
	      {
		if (!(line.equals("--- SOURCE RESULTS ---")) && !(line.equals("--- END OF RESULTS ---")) && !(line.equals("")))
		  {
		    output.add(line);
		  }
 	      }
	    in.close();	    
	  }
	catch(IOException e)
	  {
	    System.err.println("ERROR 1: Something went wrong.\n" + e);	
	  }
      }
    catch(MalformedURLException e)
      {
	System.err.println("ERROR 3: Something went wrong.\n" + e);	
      }
    return output;
  }



}

