import java.util.*;
import java.net.*;
import java.io.*;
import javax.swing.text.*; 
import java.lang.*;
import javax.swing.text.html.*;
import javax.swing.text.html.parser.*;

public class Translator {

  private String fromLanguage;
  private String toLanguage;
  private String def = new String("en_de");
  
  
  public Translator() {
    // returns the default translator English-German
    this.fromLanguage = "English";
    this.toLanguage = "German";
  }
  
  public Translator(String l) {
    //returns a translator from English to the language l
    //unless we can't translate to language l in which case the
    //default English German translator is returned.
    if(this.translatable("English", l))
      {
	this.fromLanguage = "English";
	this.toLanguage = l;
      }
    else
      {
	this.fromLanguage = "English";
	this.toLanguage = "German";
      }
  }
  


  public String translate(String s) {    

    String output = "";

    // Construct the URL of online service to use.
    try
      {
	URL source = getURL(s);
	
	// Connect to online translation service.
	OnlineConnection service_connection = new OnlineConnection(source);
	service_connection.connect();
	
	// Obtain HTML page of target online service.  (Thie HTML page
	// should contain the the output of the translation query.
	HTMLDocument document = new HTMLDocument();
	InputStream input;

	String line;

	try
	  {
	    Object o = source.getContent();
	    //	    System.out.println(o.getClass().getName());
	    input = (InputStream) o;
	    InputStreamReader isr = new InputStreamReader( input );
	    BufferedReader in = new BufferedReader( isr );
	    String myHTML = "";
	    while ( (line = in.readLine() ) != null )
	      {
		myHTML = myHTML + line;
	      }
	    in.close();	    
	   	    
	    
	    StringTokenizer st1 = new StringTokenizer(myHTML, ">", false);

	    String sss;
	    while(st1.hasMoreTokens()) {
	      sss = st1.nextToken();
	      if ((sss.length()==24) && (sss.equals("<Div style=padding:10px;")))
		{
		  sss = st1.nextToken();
		  output = sss.substring(0, sss.length() - 5);	
		}
	    }	    
	  }
	catch(IOException e)
	  {
	    System.err.println("ERROR 1: Something went wrong.\n" + e);	
	  }
      }
    catch(MalformedURLException e)
      {
	System.err.println("ERROR 3: Something went wrong.\n" + e);	
      }
    return output;
  }
  
  public String getToLang() {
    return this.toLanguage;
  }


    void setLang(String l) {
	this.toLanguage = l;
    }

    void setFromLang(String l) {
	this.fromLanguage = l;
    }




  private URL getURL(String str) throws MalformedURLException {
    String from_to = getSymbol();   


    String answer = "http://babelfish.altavista.com/babelfish/tr?doit=done&urltext=";
    
    String toTranslate = "";
    StringTokenizer st = new StringTokenizer(str);
    String next;
    
    while (st.hasMoreTokens()) {
      next = st.nextToken();
      toTranslate = toTranslate + next;
      if(st.hasMoreTokens())
	toTranslate = toTranslate + "+";
    }

    answer = answer + toTranslate;
    answer = answer + "%0D%0A&lp=" + from_to + "&search.x=30&search.y=13";

	URL r = new URL(answer);  
	return r;  
  }



  private String getSymbol() {
    String from_to = def;
    
    if(this.fromLanguage.equals("English"))
      {
	if(this.toLanguage.equals("French"))
	  from_to = "en_fr";    
	else {
	  if(this.toLanguage.equals("Spanish"))
	    from_to = "en_es";
	  else {
	    if(this.toLanguage.equals("German"))
	      from_to = "en_de";
	    else { 
	      if(this.toLanguage.equals("Italian"))
		from_to = "en_it";  
	      else {
		if(this.toLanguage.equals("Portugese"))
		  from_to = "en_pt";  
	      }
	    }
	  }
	}
      }
    

    if(this.fromLanguage.equals("French"))
      {
	if(this.toLanguage.equals("English"))
	  from_to = "fr_en";
	else {
	  if(this.toLanguage.equals("German"))
	    from_to = "fr_de";
	}
      }

    if(this.fromLanguage.equals("German"))
      {
	if(this.toLanguage.equals("English"))
	  from_to = "de_en";
	else {
	  if(this.toLanguage.equals("French"))
	    from_to = "de_fr";
	}
      }


    if(this.fromLanguage.equals("Italian"))
      {
	if(this.toLanguage.equals("English"))
	  from_to = "it_en";
      }
    
    if(this.fromLanguage.equals("Portugese"))
      {
	if(this.toLanguage.equals("English"))
	  from_to = "pt_en";
      }
    
    if(this.fromLanguage.equals("Spanish"))
      {
	if(this.toLanguage.equals("English"))
	  from_to = "es_en";
      }       
    return from_to;
  }


  
  public boolean translatable(String from, String to) {
    boolean answer = false;
    if((from.equals("English")) && 
       ((to.equals("French")) || (to.equals("German")) || 
	(to.equals("Italian")) || (to.equals("Portugese")) || 
	(to.equals("Spanish"))))
      {answer=true;}
    
    if((from.equals("French")) &&
       ((to.equals("English")) || (to.equals("German"))))
      {answer=true;}
    
    if((from.equals("German")) &&
       ((to.equals("English")) || (to.equals("French"))))
      {answer=true;}
    
    if((from.equals("Italian")) && (to.equals("English")))
      {answer=true;}

    if((from.equals("Portugese")) && (to.equals("English")))
      {answer=true;}

    if((from.equals("Spanish")) && (to.equals("English")))
      {answer=true;}

    return answer;
  }

  public ArrayList translatable(String from) {
    //give a list of languages to which we can translate from the
    //language "from".    
    String english = "English";
    String french = "French";
    String german = "German";
    String italian = "Italian";
    String portugese = "Portugese";
    String spanish = "Spanish";
    
    ArrayList list = new ArrayList();
    
    if(from.equals(english))
      {list.add(french);
      list.add(german);
      list.add(italian);
      list.add(portugese);
      list.add(spanish);
      }
    
    if(from.equals(german))
      {list.add(english);
      list.add(french);
      }
    
    if(from.equals(french))
      {list.add(english);
      list.add(german);
      }
    
    if(from.equals(italian))
      list.add(english);


    if(from.equals(portugese))
      list.add(english);


    if(from.equals(spanish))
      list.add(english);

    return list;
  }



  
}
